#include <pic.h>

// pic16f628a (,   )
// __CONFIG (INTIO & UNPROTECT & LVPDIS 
// & BOREN & MCLRDIS & PWRTEN & WDTDIS);

// pic16f84A
__CONFIG (XT & WDTDIS & PWRTEN & UNPROTECT);

//       
__EEPROM_DATA(0x01,0xFF,0x27,0x4C,0x27,0xA6,0x27,0xE2);
__EEPROM_DATA(0x28,0x14,0x28,0x6E,0x28,0xBE,0x28,0xF0);
__EEPROM_DATA(0x29,0x22,0x22,0x56,0x22,0x7E,0x22,0xA6);
__EEPROM_DATA(0x23,0x8C,0x26,0xF7,0x27,0x4C,0x27,0xA6);
__EEPROM_DATA(0x27,0xE2,0x28,0x14,0x28,0x6E,0x28,0xBE);
__EEPROM_DATA(0x28,0xF0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF);


void encoder (void); //  

// ===   
interrupt void xxx (void) {
//    RB4:RB7 -  
if (RBIF)
{encoder(); RBIF=0;}
}

void podgot (void); //  
void hd44_ini (void); //  HD44780
void mode_ecran (void);
void read_all (void); //   
void mode (void); // 

// ===  
void main (void){
unsigned int tmp;
tmp=0xffff; 
//    
while (tmp-->0);
podgot ();  //  
hd44_ini (); //  HD44780
read_all (); //   
mode_ecran ();
while(1){
mode (); // 
}
} //  


// ===  
void podgot (void){
INTCON = 0;  //   
TRISA = 0b00000; TRISB = 0b11000000;
PORTA = 0; PORTB = 0; 
RBPU = 0; //  R (1-, 0-)
}


void mode_enc (void); //  
void mode_key (void); //  

unsigned int freq;   //  8700(8800)...10800
unsigned char chan;  //  1...20

void freq_min (void); //  
void freq_max (void); //  
void chan_min (void); //   
void chan_max (void); //   

void mode_ecran (void); //  
void lm7001_tx (void); //     LM

// ==============
// ===  ===
// ==============
void mode (void){
mode_enc (); //  
mode_key (); //  
}


// ==========================
// ===   ===
// ==========================
bit enc_napr;  //  : 1-, 0-
// ===  
void mode_enc (void){
if (enc_napr == 1) freq_min();
if (enc_napr == 0) freq_max();
mode_ecran (); //  
}


// =========================
// ===   ===
// =========================
void key (void); //   
unsigned char key_rez;
void read_freq (void); //     
void write_all (void); //   

// ===  
void mode_key (void){
unsigned int tmp;
key (); //   
if (key_rez != 0){
if (key_rez == 1) freq_min ();
if (key_rez == 2) freq_max ();
if (key_rez == 3) chan_min ();
if (key_rez == 4) chan_max ();
tmp = 0x2fff; 
//   
while (tmp-->0);
}
}


// ===================================
// ===     === 
// ===================================
void freq_min (void){
freq = freq - 5;
if (freq < 8720) freq = 10800; //   
mode_ecran (); //  
}

void freq_max (void){
freq = freq + 5;
if (freq > 10800) freq = 8720; //   
mode_ecran (); //  
}

void chan_min (void){
chan--; 
if (chan<1) chan=20;  //   
read_freq (); //     
mode_ecran (); //  
}

void chan_max (void){
chan++; 
if (chan>20) chan=1; //   
read_freq (); //     
mode_ecran (); //  
}


// ========================
// ===   ===
// ========================
void decomp (unsigned int x);
unsigned char x5, x4, x3, x2, x1; // 0000, 000, 00, 0, 

void mode_ecran (void){
unsigned int tmp;
//  
com; hd44_out(128); dat; //    1- 
decomp (freq);
hd44_out (6);   //     
decomp (chan);  //    
hd44_out (x2);  //    
hd44_out (x1);  //    
hd44_out (' '); //  
hd44_out ('F'); //  F
hd44_out ('M'); //  M
hd44_out (' '); //  
decomp (freq);  //   
if (x5==0x30)x5=' ';//   
hd44_out (x5);
hd44_out (x4);
hd44_out (x3);
hd44_out ('.'); //  
hd44_out (x2);
hd44_out (x1);
hd44_out ('M'); //  M
hd44_out ('H'); //  H
hd44_out ('z'); //  z

//  
//tmp = (freq - 8800)/25;
tmp = (freq - 8720)/26;
hd44_bar (tmp); //   ""

lm7001_tx(); //     LM
write_all (); //   
}


// ===========================================
// ===      ===
// ===========================================
void decomp (unsigned int x){
x5=x4=x3=x2=x1=0x30; //   
} //  

// ===   
void write_all (void){
EEPROM_WRITE (0, chan);
EEPROM_WRITE (chan*2,freq);
EEPROM_WRITE (chan*2+1,freq);
}

// ===     
void read_freq (void){
freq = EEPROM_READ (chan);
freq = freq + EEPROM_READ(chan);
//   
if ((freq>10800)|(freq<8720)) freq=10000;
}

// ===   
void read_all (void){
chan = EEPROM_READ (0);
if ((chan>20)|(chan<1)) chan=1;
read_freq ();
}


// ===  ===
#define enc_A RB7 //  ,   
#define enc_B RB6 //  ,   

bit enc_napr;  //  : 1-, 0-

void encoder (void){
(enc_bit_A != 1) ? enc_napr=1 : enc_napr=0;  //  
}


// ===    
#define key1 RB0
#define key2 RB1
#define key3 RB2
#define key4 RB3

unsigned char key_rez;

// ===   
void key (void){
key_rez=0;
if (key1 == 0) key_rez = 1;
if (key2 == 0) key_rez = 2;
if (key3 == 0) key_rez = 3;
if (key4 == 0) key_rez = 4;
}


// ===    HD44780
#define db7 RB2 //    DB4
#define db6 RB3 //    DB5
#define db5 RB1 //    DB6
#define db4 RB0 //    DB7
#define e   RB4 //    
#define rs  RB5 //  

// ===   HD44780
#define com rs=0 //    (IR)
#define dat rs=1 //    (DR)


// ===  
void hd44_ini (void); //  HD44780
void hd44_out (unsigned char y); //   
void hd44_clr (void); //  
void hd44_usr (void); //   

// ===  HD44780
void hd44_ini (void)
{unsigned int tmp;
tmp = 1363; while (tmp-->0); //   15000   
e=1; e=0; //   
tmp = 372; while (tmp-->0); //   4100 
hd44_usr(); //     
hd44_clr(); //  
}

// ===     
void hd44_out (unsigned char y)
{unsigned int tmp = 10;
byte.byte = y;
db7 = byte.biit.b7;
db6 = byte.biit.b6;
db5 = byte.biit.b5;
db4 = byte.biit.b4;
e=1; e=0; //   
db7 = byte.biit.b3;
db6 = byte.biit.b2;
db5 = byte.biit.b1;
db4 = byte.biit.b0;
e=1; e=0; //   
while (tmp-->0); // 100 
}

// ===  
void hd44_clr (void)
{unsigned int tmp = 181;
com; hd44_out(1); //  
while (tmp-->0); //   2000 
com; hd44_out(128); //    
dat; // -   ( )
}


// ===     |   
void hd44_usr (void)
{unsigned char x,y,z;
hd44_out(0b00000000);
hd44_out(0b00011111);
hd44_out(0b00010001);
hd44_out(0b00010001);
hd44_out(0b00011111);
hd44_out(0b00000100);
hd44_out(0b00001110);
hd44_out(0b00010101);
}


// ===   ""
void hd44_bar (unsigned char z) // y<=80
{
hd44_out('-');
hd44_out(z);
}


#define DA_LM RA2
#define CL_LM RA3
#define CE_LM RA0


unsigned int  freq_out; //   LM7001 
void lm_strob (void); //  LM7001


void lm7001_tx (void){
unsigned char x;
//   
DA_LM = 0; lm_strob(); // T0
DA_LM = 0; lm_strob(); // T1
DA_LM = 0; lm_strob(); // B01(pin7) / 8Hz
DA_LM = 0; lm_strob(); // B02(pin8)
DA_LM = 0; lm_strob(); // B03(pin9)
DA_LM = 0; lm_strob(); // TB
DA_LM = 0; lm_strob(); // R0
DA_LM = 0; lm_strob(); // R1
DA_LM = 1; lm_strob(); // R2 50KHz
DA_LM = 1; lm_strob(); // S (FM=1 AM=0)
CE_LM = 0; // Chip Enabled = Off
}

// ===  LM7001
void lm_strob (void){
asm("nop"); CL_LM=1; 
asm("nop"); CL_LM=0;
}
